package cn.com.taiji.beidou.web.controller.ship;

import cn.com.taiji.beidou.common.core.controller.BaseController;
import cn.com.taiji.beidou.common.core.domain.R;
import cn.com.taiji.beidou.common.core.page.TableDataInfo;
import cn.com.taiji.beidou.common.utils.StringUtils;
import cn.com.taiji.beidou.ship.archives.BeiDouShipInfo;
import cn.com.taiji.beidou.ship.archives.domain.ShipArchivesData;
import cn.com.taiji.beidou.ship.archives.domain.ShipArchivesREQ;
import cn.com.taiji.beidou.ship.archives.domain.ShipArchivesTotal;
import cn.com.taiji.beidou.ship.archives.domain.ShipDisposeData;
import cn.com.taiji.beidou.ship.archives.service.ShipArchivesService;
import com.github.pagehelper.PageHelper;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiOperation;
import org.springframework.web.bind.annotation.GetMapping;
import org.springframework.web.bind.annotation.PostMapping;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RestController;

import javax.annotation.Resource;
import java.util.List;

/**
 * @Author CHEN
 * @Date 2022/11/8 18:55
 */
@Api(tags = "船舶档案")
@RestController
public class ShipArchivesController extends BaseController {

    @Resource
    private ShipArchivesService shipArchivesService;

    @Resource
    private BeiDouShipInfo beiDouShipInfo;

    @ApiOperation("获取船舶档案列表")
    @PostMapping("/shipList")
    public TableDataInfo getShip(@RequestBody ShipArchivesREQ req){

        if (StringUtils.isNotNull(req.getPageNum()) && StringUtils.isNotNull(req.getPageSize())) {
            PageHelper.startPage(req.getPageNum(), req.getPageSize());
        }else {
            startPage();
        }
        req.setDevideNo(req.getShipId());
        List<ShipArchivesData> shipList = shipArchivesService.findShipList(req);
        return getDataTable(shipList);

    }

    @ApiOperation("获取船舶详情")
    @GetMapping("/shipDetail")
    public R<ShipArchivesData> findShipDetail(String shipId){

        try {
            ShipArchivesData shipById = shipArchivesService.findShipById(shipId);
            return R.ok(shipById);
        }catch (Exception e){
            return R.fail(e.getMessage());
        }

    }

    @ApiOperation("处置过程详情")
    @GetMapping("/disposeDetail")
    public R<ShipDisposeData> disposeDetail(String warningId){

        try {
            ShipDisposeData shipDisposeData = shipArchivesService.selectDisposeById(warningId);

            return R.ok(shipDisposeData);
        }catch (Exception e){
            return R.fail(e.getMessage());
        }

    }
    @ApiOperation("船舶档案统计")
    @GetMapping("/getShipTotal")
    public R<ShipArchivesTotal> getShipTotal(){

        return null;
    }

    //@ApiOperation("获取船舶档案信息")
    @GetMapping("/shipInfo")
    public R shipInfo(){
        beiDouShipInfo.beidouShipInfo();
        return null;
    }
}
